Public Bike Management (30)(dfs)

链接:https://www.nowcoder.com/questionTerminal/4b20ed271e864f06ab77a984e71c090f
来源:牛客网

There is a public bike service in Hangzhou City which provides great convenience to the tourists from all over the world. One may rent a bike at any station and return it to any other stations in the city.
The Public Bike Management Center (PBMC) keeps monitoring the real-time capacity of all the stations. A station is said to be in perfect condition if it is exactly half-full. If a station is full or empty, PBMC will collect or send bikes to adjust the condition of that station to perfect. And more, all the stations on the way will be adjusted as well.
When a problem station is reported, PBMC will always choose the shortest path to reach that station. If there are more than one shortest path, the one that requires the least number of bikes sent from PBMC will be chosen.

Figure 1
Figure 1 illustrates an example. The stations are represented by vertices and the roads correspond to the edges. The number on an edge is the time taken to reach one end station from another. The number written inside a vertex S is the current number of bikes stored at S. Given that the maximum capacity of each station is 10. To solve the problem at S3 , we have 2 different shortest paths:

  1. PBMC -> S1 -> S3 . In this case, 4 bikes must be sent from PBMC, because we can collect 1 bike from S1 and then take 5 bikes to S3 , so that both stations will be in perfect conditions.
  2. PBMC -> S2 -> S3 . This path requires the same time as path 1, but only 3 bikes sent from PBMC and hence is the one that will be chosen.
    输入描述:

Each input file contains one test case. For each case, the first line contains 4 numbers: Cmax (<= 100), always an even number, is the maximum capacity of each station; N (<= 500), the total number of stations; Sp, the index of the problem station (the stations are numbered from 1 to N, and PBMC is represented by the vertex 0); and M, the number of roads. The second line contains N non-negative numbers Ci (i=1,…N) where each Ci is the current number of bikes at Si respectively. Then M lines follow, each contains 3 numbers: Si, Sj, and Tij which describe the time Tij taken to move betwen stations Si and Sj. All the numbers in a line are separated by a space.

输出描述:

For each test case, print your results in one line. First output the number of bikes that PBMC must send. Then after one space, output the path in the format: 0->S1->…->Sp. Finally after another space, output the number of bikes that we must take back to PBMC after the condition of Sp is adjusted to perfect.
Note that if such a path is not unique, output the one that requires minimum number of bikes that we must take back to PBMC. The judge’s data guarantee that such a path is unique.
示例1
输入

10 3 3 5
6 7 0
0 1 1
0 2 1
0 3 3
1 3 1
2 3 1
输出

3 0->2->3 0

翻译:
大概就是:给一个无向图,每个节点无camx的一半,求从起点到终点所经历时间最短,从初始点搬运的车最少,返回的车最少的一条路
思路:
这道题我们要求最短路,看看数据其实不用迪杰斯特拉,我们直接暴力搜记录路径即可。

#include <iostream>
#include <vector>
#include <limits.h>
  
using namespace std;
  
void dfs(int start, int index, int end);
  
int cmax, N, sp, M;
int costTimes, outBikes, inBikes;
int resultTimes = INT_MAX;
int resultOutBikes, resultInBikes;
vector<int> bikes, path, resultPath;
vector<vector<int> > times;
vector<bool> visited;
  
int main()
 
{
    ios::sync_with_stdio(false);
    // 输入数据
    cin >> cmax >> N >> sp >> M;
    bikes.resize(N+1, 0);
    visited.resize(N+1, false);
    times.resize(N+1, vector<int>(N+1, 0));
    for(int i=1; i<=N; i++) {
        cin >> bikes[i];
    }
    int m, n, dist;
    for(int i=0; i<M; i++) {
        cin >> m >> n >> dist;
        times[m][n] = dist;
        times[n][m] = dist;
    }
  
    // 深搜并输出结果
    dfs(0, 0, sp);
    cout << resultOutBikes << " 0";
    for(int i=1; i<resultPath.size(); i++) {
        cout << "->" << resultPath[i];
    }
    cout << " " << resultInBikes;
  
    return 0;
}
  
void dfs(int start, int index, int end)
{
    // 先对这个点标记一下
    visited[index] = true;
    path.push_back(index);
    costTimes += times[start][index];
  
    // 处理
    if(index == end) {
        // 计算这条路上带去的车和带回的车
        inBikes = 0, outBikes = 0;
        for(int i=1; i<path.size(); i++) {
            //如果这个结点多了就多了加入inbikes
            if(bikes[path[i]] > cmax/2) {
                inBikes += bikes[path[i]] -cmax/2;
            } else {
                if((cmax/2 - bikes[path[i]]) < inBikes) {
                    //如果这个结点少了,但是少的数量可以从前面inbikes拿到就减少inbikes
                    inBikes -= (cmax/2 - bikes[path[i]]);
                } else {//如果前面inbikes不够就从起点拿
                    outBikes += (cmax/2 - bikes[path[i]]) - inBikes;
                    inBikes = 0;
                }
            }
        }
        // 判断这条路是否更好,如果时间最短就ok了
        if(costTimes != resultTimes) {
            if(costTimes < resultTimes) {
                resultTimes = costTimes;
                resultPath = path;
                resultOutBikes = outBikes;
                resultInBikes = inBikes;
            }//如果时间相同,丢出的最少就ok
        } else if(outBikes != resultOutBikes) {
            if(outBikes < resultOutBikes) {
                resultPath = path;
                resultOutBikes = outBikes;
                resultInBikes = inBikes;
            }//如果丢出也相同就求最小的丢入
        } else if(inBikes < resultInBikes) {
            resultPath = path;
            resultOutBikes = outBikes;
            resultInBikes = inBikes;
        }
    } else {
        // 递归,遍历他下一个节点,如果没有被访问并且有路就遍历
        for(int i=1; i<=N; i++) {
            if(times[index][i] != 0 && !visited[i]) {
                dfs(index, i, end);
            }
        }
    }
  
    // 回溯,另外选一个分支遍历
    visited[index] = false;
    path.pop_back();
    costTimes -= times[start][index];
}

猜你喜欢

转载自blog.csdn.net/starmoth/article/details/84573219